

Type TEditorGuiObjects
	Field Window:NUI_Window
	
	Field Tabber:NUI_Tabber
	
	Field Objects:NUI_TabPage
	
		Field Tree:NUI_TreeView
	
		Field Creations:NUI_TreeViewNode
		Field CreationsSmall:NUI_TreeViewNode
		Field CreationsBig:NUI_TreeViewNode
		Field CreationsSnakes:NUI_TreeViewNode
		Field Portals:NUI_TreeViewNode
		Field Bonus:NUI_TreeViewNode
		Field Special:NUI_TreeViewNode

		Field CreateObject:NUI_Button
	
	Field LevelObjects:NUI_TabPage
	
		Field SelectObject:NUI_Button
		Field DeleteObject:NUI_Button
	
		Field LevelTree:NUI_TreeView
	
	Field ObjectPropertys:NUI_TabPage

		Field ObjectAI:NUI_ComboBox
			Field ObjectAI_None:NUI_ComboBoxItem
			Field ObjectAI_Null:NUI_ComboBoxItem
			Field ObjectAI_Simple:NUI_ComboBoxItem
			Field ObjectAI_Snake:NUI_ComboBoxItem
			Field ObjectAI_JellyFish:NUI_ComboBoxItem
			Field ObjectAI_Shell:NUI_ComboBoxItem
			Field ObjectAI_Star:NUI_ComboBoxItem
			Field ObjectAI_DNAVirus:NUI_ComboBoxItem
	
		Field ObjectAIAgressive:NUI_ComboBox
			Field ObjectAIAgressive_Max:NUI_ComboBoxItem
			Field ObjectAIAgressive_On:NUI_ComboBoxItem
			Field ObjectAIAgressive_Off:NUI_ComboBoxItem
			Field ObjectAIAgressive_None:NUI_ComboBoxItem
		
		Field ObjectAIRotateSpeed:NUI_TextBox
	
		Field ObjectEatingEnable:NUI_ComboBox
			Field ObjectEatingEnable_On:NUI_ComboBoxItem
			Field ObjectEatingEnable_Off:NUI_ComboBoxItem
		
		Field ObjectGroup:NUI_TextBox
		Field ObjectMoveSpeed:NUI_TextBox
		Field ObjectTurnSpeed:NUI_TextBox

		Field ObjectPointsType:NUI_ComboBox
			Field ObjectPoints_1:NUI_ComboBoxItem
			Field ObjectPoints_2:NUI_ComboBoxItem
			Field ObjectPoints_3:NUI_ComboBoxItem
			Field ObjectPoints_4:NUI_ComboBoxItem
			Field ObjectPoints_5:NUI_ComboBoxItem
			Field ObjectPoints_6:NUI_ComboBoxItem
			Field ObjectPoints_Your:NUI_ComboBoxItem
		Field ObjectPointsValue:NUI_TextBox

		Field ObjectMoneyType:NUI_ComboBox
			Field ObjectMoney_1:NUI_ComboBoxItem
			Field ObjectMoney_2:NUI_ComboBoxItem
			Field ObjectMoney_3:NUI_ComboBoxItem
			Field ObjectMoney_4:NUI_ComboBoxItem
			Field ObjectMoney_5:NUI_ComboBoxItem
			Field ObjectMoney_6:NUI_ComboBoxItem
			Field ObjectMoney_Your:NUI_ComboBoxItem
		Field ObjectMoneyValue:NUI_TextBox

		Field ObjectSoundOnDie:NUI_TextBox
		Field ObjectSoundOnEating:NUI_TextBox

		Field ObjectUpdate:NUI_Button
	
	Field PortalPropertys:NUI_TabPage

		Field PortalType:NUI_ComboBox
			Field PortalType_Null:NUI_ComboBoxItem
			Field PortalType_Prev:NUI_ComboBoxItem
			Field PortalType_Next:NUI_ComboBoxItem
			Field PortalType_World:NUI_ComboBoxItem

		Field PortalLevelID:NUI_TextBox
		Field PortalUpdate:NUI_Button

	Field Scripting:NUI_TabPage
	
		Field ScriptTree:NUI_TreeView
		Field ScriptAdd:NUI_Button
		Field ScriptRemove:NUI_Button
		Field ScriptUpdate:NUI_Button
	
		Field ScriptType:NUI_ComboBox
			Field ScriptType_Null:NUI_ComboBoxItem
			Field ScriptType_ChangeBGMusic:NUI_ComboBoxItem
			Field ScriptType_DropBonus:NUI_ComboBoxItem
			Field ScriptType_DropCreation:NUI_ComboBoxItem
			Field ScriptType_ChageBGColor:NUI_ComboBoxItem
			Field ScriptType_CreationInfo:NUI_ComboBoxItem
			Field ScriptType_TextParametrs:NUI_ComboBoxItem
			
		Field ScriptParam1:NUI_TextBox
		Field ScriptParam2:NUI_TextBox
		Field ScriptParam3:NUI_TextBox
		Field ScriptParam4:NUI_TextBox
	

	Function Create:TEditorGuiObjects()
		Local gm:TEditorGuiObjects = New TEditorGuiObjects
		gm.Init()
		Return gm
	End Function
	
	Function OnClose(sender:NUI_Window,cancel:Int Var)
		cancel = True
		sender.Minimize()
	End Function
	
	Method MouseOnWindow%()
		Local mx% = ((MouseX() < (Window._area.X - Window._padding.LeftSide)) Or (MouseX() > (Window._area.X + Window._area.Width - Window._padding.RightSide)))
		Local my% = ((MouseY() < (Window._area.Y + Window._padding.TopSide)) Or (MouseY() > (Window._area.Y + Window._area.Height + Window._padding.BottomSide)))
		If mx Or my Then
			Return 0
		Else
			Return 1
		End If
	End Method
	
	Method Init()
		
		If Editor.OneWindow = 0 Then
			Window = NUI_Window.Create("jEditor Objects", 0, 0, 420, 350, NGui,Null)
			Window.OnClose = TEditorGuiObjects.OnClose
			Window.SetBorderMode(NUI_WINDOW_BORDER_NORMAL_SIZABLE)
			Window._minimizeAreaMove.Width = 120

			Window.Minimize()
			Window.SetMaximizeShown(0)
		
			Tabber = NUI_Tabber.Create(2,2,398,298,NGui,Window)
		Else
			Window = Editor.GuiMain.Window
			Tabber = Editor.GuiMain.Tabber
		End If
		
		Objects = NUI_TabPage.Create("Create",NGui,Tabber)
		
			Tree = NUI_TreeView.Create(10,10,350,190,NGui,Objects)

			Creations = NUI_TreeViewNode.Create("Creations",NGui,Tree)
			Creations.SetIcon(Editor.TreeImg)

			CreationsSmall = NUI_TreeViewNode.Create("Small",NGui,Creations)
			CreationsSmall.SetIcon(Editor.TreeImg)
			Editor.CreationsDB.CreateTreeViewList(CreationsSmall,Editor.CreationsDB.GroupSmall)

			CreationsBig = NUI_TreeViewNode.Create("Big",NGui,Creations)
			CreationsBig.SetIcon(Editor.TreeImg)
			Editor.CreationsDB.CreateTreeViewList(CreationsBig,Editor.CreationsDB.GroupBig)

			CreationsSnakes = NUI_TreeViewNode.Create("Snakes",NGui,Creations)
			CreationsSnakes.SetIcon(Editor.TreeImg)
			Editor.CreationsDB.CreateTreeViewList(CreationsSnakes,Editor.CreationsDB.GroupSnakes)

			Portals = NUI_TreeViewNode.Create("Portals",NGui,Tree)
			Portals.SetIcon(Editor.TreeImg)
			Editor.CreationsDB.CreateTreeViewList(Portals,Editor.CreationsDB.GroupPortals)

			Bonus = NUI_TreeViewNode.Create("Bonus",NGui,Tree)
			Bonus.SetIcon(Editor.TreeImg)
			Editor.CreationsDB.CreateTreeViewList(Bonus,Editor.CreationsDB.GroupBonus)

			Special = NUI_TreeViewNode.Create("Special",NGui,Tree)
			Special.SetIcon(Editor.TreeImg)
			Editor.CreationsDB.CreateTreeViewList(Special,Editor.CreationsDB.GroupOther)
				
			CreateObject = NUI_Button.Create("Create",15,210,100,30,NGui,Objects)
			CreateObject.OnPress = TEditorGuiObjects.CreateObjectOnPress

		LevelObjects = NUI_TabPage.Create("Lvl Objs",NGui,Tabber)
		
			LevelTree = NUI_TreeView.Create(10,10,350,190,NGui,LevelObjects)
			
			SelectObject = NUI_Button.Create("Select",15,210,100,30,NGui,LevelObjects)
				SelectObject.OnPress = TEditorGuiObjects.OnLevelSelectObjects
			
			DeleteObject = NUI_Button.Create("Delete",135,210,100,30,NGui,LevelObjects)
				DeleteObject.OnPress = TEditorGuiObjects.OnLevelDeleteObjects

		ObjectPropertys = NUI_TabPage.Create("Obj Ini",NGui,Tabber)
			ObjectPropertys.OnSelected = TEditorGuiObjects.OnSetObjectParemetrs
		
			ObjectAI = NUI_ComboBox.Create(10,10,100,20,NGui,ObjectPropertys)
				ObjectAI_None = NUI_ComboBoxItem.Create("AI None",NGui,ObjectAI)
				ObjectAI_Null = NUI_ComboBoxItem.Create("AI Null",NGui,ObjectAI)
				ObjectAI_Simple = NUI_ComboBoxItem.Create("AI Simple",NGui,ObjectAI)
				ObjectAI_Snake = NUI_ComboBoxItem.Create("AI Snake",NGui,ObjectAI)
				ObjectAI_JellyFish = NUI_ComboBoxItem.Create("AI JellyFish",NGui,ObjectAI)
				ObjectAI_Shell = NUI_ComboBoxItem.Create("AI Shell",NGui,ObjectAI)
				ObjectAI_Star = NUI_ComboBoxItem.Create("AI Star",NGui,ObjectAI)
				ObjectAI_DNAVirus = NUI_ComboBoxItem.Create("AI DNAVirus",NGui,ObjectAI)
				NUI_ToolTip.Create("Ai Type",NGui,ObjectAI)
			
			ObjectAIAgressive = NUI_ComboBox.Create(120,10,100,20,NGui,ObjectPropertys)
				ObjectAIAgressive_Max = NUI_ComboBoxItem.Create("Agresive Max",NGui,ObjectAIAgressive)
				ObjectAIAgressive_On = NUI_ComboBoxItem.Create("Agresive",NGui,ObjectAIAgressive)
				ObjectAIAgressive_Off = NUI_ComboBoxItem.Create("Not Agresive",NGui,ObjectAIAgressive)
				ObjectAIAgressive_None = NUI_ComboBoxItem.Create("None",NGui,ObjectAIAgressive)
				NUI_ToolTip.Create("Ai Agressive",NGui,ObjectAIAgressive)
			
			ObjectAIRotateSpeed = NUI_TextBox.Create(230,10,100,20,NGui,ObjectPropertys)
				NUI_ToolTip.Create("Snake Rotation Speed",NGui,ObjectAIRotateSpeed)

			ObjectEatingEnable = NUI_ComboBox.Create(10,40,100,20,NGui,ObjectPropertys)
				ObjectEatingEnable_On = NUI_ComboBoxItem.Create("Eating On",NGui,ObjectEatingEnable)
				ObjectEatingEnable_Off = NUI_ComboBoxItem.Create("Eating Off",NGui,ObjectEatingEnable)
				NUI_ToolTip.Create("Eating",NGui,ObjectEatingEnable)
			
			ObjectGroup = NUI_TextBox.Create(120,40,100,20,NGui,ObjectPropertys)
				NUI_ToolTip.Create("Creation Group (0 - disable)",NGui,ObjectGroup)

			ObjectMoveSpeed = NUI_TextBox.Create(10,70,100,20,NGui,ObjectPropertys)
				NUI_ToolTip.Create("Creation Move Speed",NGui,ObjectMoveSpeed)

			ObjectTurnSpeed = NUI_TextBox.Create(120,70,100,20,NGui,ObjectPropertys)
				NUI_ToolTip.Create("Creation Turn Speed",NGui,ObjectTurnSpeed)
				
			ObjectPointsType = NUI_ComboBox.Create(10,100,100,20,NGui,ObjectPropertys)
				ObjectPoints_1 = NUI_ComboBoxItem.Create("Points Minimal 1 ("+TCreation.CreationPointsCostMinimal1+")",NGui,ObjectPointsType)
				ObjectPoints_2 = NUI_ComboBoxItem.Create("Points Minimal 2 ("+TCreation.CreationPointsCostMinimal2+")",NGui,ObjectPointsType)
				ObjectPoints_3 = NUI_ComboBoxItem.Create("Points Middle 1 ("+TCreation.CreationPointsCostMiddle1+")",NGui,ObjectPointsType)
				ObjectPoints_4 = NUI_ComboBoxItem.Create("Points Middle 2 ("+TCreation.CreationPointsCostMiddle2+")",NGui,ObjectPointsType)
				ObjectPoints_5 = NUI_ComboBoxItem.Create("Points Hard 1 ("+TCreation.CreationPointsCostHard1+")",NGui,ObjectPointsType)
				ObjectPoints_6 = NUI_ComboBoxItem.Create("Points Hard 2 ("+TCreation.CreationPointsCostHard2+")",NGui,ObjectPointsType)
				ObjectPoints_Your = NUI_ComboBoxItem.Create("Other",NGui,ObjectPointsType)
				NUI_ToolTip.Create("Creation Points Cost, Other mean that you can write your value",NGui,ObjectPointsType)

			ObjectPointsValue = NUI_TextBox.Create(120,100,100,20,NGui,ObjectPropertys)
				NUI_ToolTip.Create("Other value for creation points cost",NGui,ObjectPointsValue)

			ObjectMoneyType = NUI_ComboBox.Create(10,130,100,20,NGui,ObjectPropertys)
				ObjectMoney_1 = NUI_ComboBoxItem.Create("Money Minimal 1 ("+TCreation.CreationMoneyCostMinimal1+")",NGui,ObjectMoneyType)
				ObjectMoney_2 = NUI_ComboBoxItem.Create("Money Minimal 2 ("+TCreation.CreationMoneyCostMinimal2+")",NGui,ObjectMoneyType)
				ObjectMoney_3 = NUI_ComboBoxItem.Create("Money Middle 1 ("+TCreation.CreationMoneyCostMiddle1+")",NGui,ObjectMoneyType)
				ObjectMoney_4 = NUI_ComboBoxItem.Create("Money Middle 2 ("+TCreation.CreationMoneyCostMiddle2+")",NGui,ObjectMoneyType)
				ObjectMoney_5 = NUI_ComboBoxItem.Create("Money Hard 1 ("+TCreation.CreationMoneyCostHard1+")",NGui,ObjectMoneyType)
				ObjectMoney_6 = NUI_ComboBoxItem.Create("Money Hard 2 ("+TCreation.CreationMoneyCostHard2+")",NGui,ObjectMoneyType)
				ObjectMoney_Your = NUI_ComboBoxItem.Create("Other",NGui,ObjectMoneyType)
				NUI_ToolTip.Create("Creation Money Cost, Other mean that you can write your value",NGui,ObjectMoneyType)

			ObjectMoneyValue = NUI_TextBox.Create(120,130,100,20,NGui,ObjectPropertys)
				NUI_ToolTip.Create("Other value for creation money cost",NGui,ObjectMoneyValue)

			ObjectSoundOnDie = NUI_TextBox.Create(10,160,100,20,NGui,ObjectPropertys)
				NUI_ToolTip.Create("Sound that played on die (def:"+Sound_OnDie+")",NGui,ObjectSoundOnDie)
				
			ObjectSoundOnEating = NUI_TextBox.Create(120,160,100,20,NGui,ObjectPropertys)
				NUI_ToolTip.Create("Sound that played on eating (def:"+Sound_OnEating+")",NGui,ObjectSoundOnEating)
				
			ObjectUpdate = NUI_Button.Create("Update Info",10,210,100,20,NGui,ObjectPropertys)
				ObjectUpdate.OnPress = TEditorGuiObjects.OnUpdateObjectParemetrs

		PortalPropertys = NUI_TabPage.Create("Portal",NGui,Tabber)
			PortalPropertys.OnSelected = TEditorGuiObjects.OnSetPortalParemetrs

			PortalType = NUI_ComboBox.Create(10,10,100,20,NGui,PortalPropertys)
				PortalType_Next = NUI_ComboBoxItem.Create("Next Level",NGui,PortalType)
				PortalType_Prev = NUI_ComboBoxItem.Create("Prev Level",NGui,PortalType)
				PortalType_World = NUI_ComboBoxItem.Create("Next World",NGui,PortalType)
				PortalType_Null = NUI_ComboBoxItem.Create("Null",NGui,PortalType)
		
			PortalLevelID = NUI_TextBox.Create(120,10,100,20,NGui,PortalPropertys)
				NUI_ToolTip.Create("Portal Level\World ID",NGui,PortalLevelID)
				
			PortalUpdate = NUI_Button.Create("Update Info",10,210,100,20,NGui,PortalPropertys)
				PortalUpdate.OnPress = TEditorGuiObjects.OnUpdatePortalParemetrs
		
		Scripting = NUI_TabPage.Create("Scripting",NGui,Tabber)
			Scripting.OnSelected = TEditorGuiObjects.OnSetScriptParemetrs
			
			ScriptTree = NUI_TreeView.Create(10,10,150,130,NGui,Scripting)
				ScriptTree.OnSelectionChanged = TEditorGuiObjects.OnScriptTreeSelect
			
			ScriptAdd = NUI_Button.Create("Add",165,10,50,20,NGui,Scripting)
				ScriptAdd.OnPress = TEditorGuiObjects.OnAddScriptButton
			
			ScriptRemove = NUI_Button.Create("Remove",165,40,50,20,NGui,Scripting)
				ScriptRemove.OnPress = TEditorGuiObjects.OnRemoveScriptButton
			
			ScriptType = NUI_ComboBox.Create(10,180,150,25,NGui,Scripting)
				ScriptType_ChangeBGMusic = NUI_ComboBoxItem.Create("Change BG Music",NGui,ScriptType)
				ScriptType_TextParametrs = NUI_ComboBoxItem.Create("Text Parametrs",NGui,ScriptType)
				ScriptType_CreationInfo = NUI_ComboBoxItem.Create("Creation Info",NGui,ScriptType)
				ScriptType_ChageBGColor = NUI_ComboBoxItem.Create("Change BG Color",NGui,ScriptType)
				ScriptType_DropBonus = NUI_ComboBoxItem.Create("Drop Bonus",NGui,ScriptType)
				ScriptType_DropCreation = NUI_ComboBoxItem.Create("Drop Creation",NGui,ScriptType)
				ScriptType_Null = NUI_ComboBoxItem.Create("Null",NGui,ScriptType)
				ScriptType.OnSelectionChanged = TEditorGuiObjects.OnScriptTypeSelect
		
			ScriptParam1 = NUI_TextBox.Create(10,215,70,25,NGui,Scripting)
				NUI_ToolTip.Create("Script Param 1",NGui,ScriptParam1)
				
			ScriptParam2 = NUI_TextBox.Create(90,215,70,25,NGui,Scripting)
				NUI_ToolTip.Create("Script Param 2",NGui,ScriptParam2)
				
			ScriptParam3 = NUI_TextBox.Create(170,215,70,25,NGui,Scripting)
				NUI_ToolTip.Create("Script Param 3",NGui,ScriptParam3)
				
			ScriptParam4 = NUI_TextBox.Create(250,215,70,25,NGui,Scripting)
				NUI_ToolTip.Create("Script Param 4",NGui,ScriptParam4)

			ScriptUpdate = NUI_Button.Create("Update",10,245,100,20,NGui,Scripting)
				ScriptUpdate.OnPress = TEditorGuiObjects.OnUpdateScriptParemetrs

	End Method
	
	Field CreateObjectMode% = 0
	Field CreateObjectSelect:NUI_TreeViewNode

	Field RotateEnable% = 0
	Field RotateAngle#
	Field RotateWorldPosX#
	Field RotateWorldPosY#
	Field RotateCreation:TCreation
	
	Field SelectionMode% = 0
	Field SelectionStartX#
	Field SelectionStartY#
	Field SelectionEndX#
	Field SelectionEndY#
	
	Field MovingMode% = 0
	
	Field RotatingMode% = 0
	Field RotatingAngle# = 0
	
	Field SelectedObjects:TEditorSelectedObjects
	
	Function CreateObjectOnPress(sender:NUI_Control)
		Local obj:TEditorGuiObjects = Editor.GuiObjects
		
		Local obj2:NUI_TreeViewNode = obj.Tree._selectedNode
		
		If obj2 <> Null Then
			obj.CreateObjectMode = 1
			obj.CreateObjectSelect = obj2
		End If
	End Function
	
	Function OnUpdateObjectParemetrs(sender:NUI_Control)
		Local go:TEditorGuiObjects = Editor.GuiObjects
		
		If go.SelectedObjects = Null Then Return
		If go.SelectedObjects.Objs.Count() <> 1 Then Return
		
		Local cr:TCreation = TCreation(go.SelectedObjects.Objs.Last())
		
		cr.Ai.Free()
		Select go.ObjectAI.GetSelectedItem()
		Case go.ObjectAI_None
		Case go.ObjectAI_Null
			cr.Ai = TCreationAiNull.Create(cr)
		Case go.ObjectAI_Simple
			cr.Ai = TCreationAiSimple.Create(cr)
		Case go.ObjectAI_Snake
			cr.Ai = TCreationAiSnake.Create(cr)
			
			TCreationAiSnake(cr.Ai).Aggresive = 0
			If go.ObjectAIAgressive.GetSelectedItem() = go.ObjectAIAgressive_On Then TCreationAiSnake(cr.Ai).Aggresive = 1
			If go.ObjectAIAgressive.GetSelectedItem() = go.ObjectAIAgressive_Max Then TCreationAiSnake(cr.Ai).Aggresive = 2
		Case go.ObjectAI_JellyFish
			cr.Ai = TCreationAiJellyFish.Create(cr)
		Case go.ObjectAI_Shell
			cr.Ai = TCreationAiShell.Create(cr)
		Case go.ObjectAI_Star
			cr.Ai = TCreationAiStar.Create(cr)
		Case go.ObjectAI_DNAVirus
			cr.Ai = TCreationAiDNAVirus.Create(cr)
		Default
		End Select
		
		If go.ObjectEatingEnable.GetSelectedItem() = go.ObjectEatingEnable_On Then
			cr.EatingEnable = 1
		Else
			cr.EatingEnable = 0
		End If
		
		Select go.ObjectPointsType.GetSelectedItem()
		Case go.ObjectPoints_1
			cr.CreationPointsType = 1
		Case go.ObjectPoints_2
			cr.CreationPointsType = 2
		Case go.ObjectPoints_3
			cr.CreationPointsType = 3
		Case go.ObjectPoints_4
			cr.CreationPointsType = 4
		Case go.ObjectPoints_5
			cr.CreationPointsType = 5
		Case go.ObjectPoints_6
			cr.CreationPointsType = 6
		Case go.ObjectPoints_Your
			cr.CreationPointsType = 7
			cr.CreationPointsCostValue = go.ObjectPointsValue.GetText().ToInt()
		Default
		End Select
		
		Select go.ObjectMoneyType.GetSelectedItem()
		Case go.ObjectMoney_1
			cr.CreationMoneyType = 1
		Case go.ObjectMoney_2
			cr.CreationMoneyType = 2
		Case go.ObjectMoney_3
			cr.CreationMoneyType = 3
		Case go.ObjectMoney_4
			cr.CreationMoneyType = 4
		Case go.ObjectMoney_5
			cr.CreationMoneyType = 5
		Case go.ObjectMoney_6
			cr.CreationMoneyType = 6
		Case go.ObjectMoney_Your
			cr.CreationMoneyType = 7
			cr.CreationMoneyCostValue = go.ObjectMoneyValue.GetText().ToInt()
		Default
		End Select
		
		cr.CreationGroup = go.ObjectGroup.GetText().ToInt()
		cr.MoveSpeed = go.ObjectMoveSpeed.GetText().ToFloat()
		cr.TurnSpeed = go.ObjectTurnSpeed.GetText().ToFloat()
		
		cr.OnDie_SoundName = go.ObjectSoundOnDie.GetText()
		cr.OnEating_SoundName = go.ObjectSoundOnEating.GetText()
	End Function
	
	Function OnSetObjectParemetrs(sender:NUI_TabPage,cancel:Int Var)
	
		Local go:TEditorGuiObjects = Editor.GuiObjects
		
		If go.SelectedObjects = Null Then Return
		If go.SelectedObjects.Objs.Count() <> 1 Then Return
		
		Local cr:TCreation = TCreation(go.SelectedObjects.Objs.Last())
		
		If cr.Ai <> Null Then
			Select cr.Ai.AiType
			Case "AiNull"
				go.ObjectAI.SelectItem(go.ObjectAI_Null)
				go.ObjectAIAgressive.SelectItem(go.ObjectAIAgressive_None)
				go.ObjectAIRotateSpeed.SetText("None")
			Case "AiSimple"
				go.ObjectAI.SelectItem(go.ObjectAI_Simple)
				go.ObjectAIAgressive.SelectItem(go.ObjectAIAgressive_None)
				go.ObjectAIRotateSpeed.SetText("None")
			Case "AiSnake"
				go.ObjectAI.SelectItem(go.ObjectAI_Snake)
				go.ObjectAIAgressive.SelectItem(go.ObjectAIAgressive_Off)
				If TCreationAiSnake(cr.Ai).Aggresive = 1 Then go.ObjectAIAgressive.SelectItem(go.ObjectAIAgressive_On)
				If TCreationAiSnake(cr.Ai).Aggresive = 2 Then go.ObjectAIAgressive.SelectItem(go.ObjectAIAgressive_Max)
				go.ObjectAIRotateSpeed.SetText("None")
			Case "AiJellyFish"
				go.ObjectAI.SelectItem(go.ObjectAI_JellyFish)
				go.ObjectAIAgressive.SelectItem(go.ObjectAIAgressive_None)
				go.ObjectAIRotateSpeed.SetText("None")
			Case "AiShell"
				go.ObjectAI.SelectItem(go.ObjectAI_Shell)
				go.ObjectAIAgressive.SelectItem(go.ObjectAIAgressive_None)
				go.ObjectAIRotateSpeed.SetText("None")
			Case "AiStar"
				go.ObjectAI.SelectItem(go.ObjectAI_Star)
				go.ObjectAIAgressive.SelectItem(go.ObjectAIAgressive_None)
				go.ObjectAIRotateSpeed.SetText("None")
			Case "AiDNAVirus"
				go.ObjectAI.SelectItem(go.ObjectAI_DNAVirus)
				go.ObjectAIAgressive.SelectItem(go.ObjectAIAgressive_None)
				go.ObjectAIRotateSpeed.SetText("None")
			Default
			End Select
		Else
			go.ObjectAI.SelectItem(go.ObjectAI_None)
			go.ObjectAIAgressive.SelectItem(go.ObjectAIAgressive_None)
			go.ObjectAIRotateSpeed.SetText("None")
		End If
		
		If cr.EatingEnable = 1 Then
			go.ObjectEatingEnable.SelectItem(go.ObjectEatingEnable_On)
		Else
			go.ObjectEatingEnable.SelectItem(go.ObjectEatingEnable_Off)
		End If
		
		go.ObjectPointsValue.SetText("0")
		Select cr.CreationPointsType
		Case 1
			go.ObjectPointsType.SelectItem(go.ObjectPoints_1)
		Case 2
			go.ObjectPointsType.SelectItem(go.ObjectPoints_2)
		Case 3
			go.ObjectPointsType.SelectItem(go.ObjectPoints_3)
		Case 4
			go.ObjectPointsType.SelectItem(go.ObjectPoints_4)
		Case 5
			go.ObjectPointsType.SelectItem(go.ObjectPoints_5)
		Case 6
			go.ObjectPointsType.SelectItem(go.ObjectPoints_6)
		Case 7
			go.ObjectPointsType.SelectItem(go.ObjectPoints_Your)
			go.ObjectPointsValue.SetText(Int(cr.CreationPointsCostValue))
		Default
			go.ObjectPointsType.SelectItem(Null)
		End Select
		
		go.ObjectMoneyValue.SetText("0")
		Select cr.CreationMoneyType
		Case 1
			go.ObjectMoneyType.SelectItem(go.ObjectMoney_1)
		Case 2
			go.ObjectMoneyType.SelectItem(go.ObjectMoney_2)
		Case 3
			go.ObjectMoneyType.SelectItem(go.ObjectMoney_3)
		Case 4
			go.ObjectMoneyType.SelectItem(go.ObjectMoney_4)
		Case 5
			go.ObjectMoneyType.SelectItem(go.ObjectMoney_5)
		Case 6
			go.ObjectMoneyType.SelectItem(go.ObjectMoney_6)
		Case 7
			go.ObjectMoneyType.SelectItem(go.ObjectMoney_Your)
			go.ObjectMoneyValue.SetText(Int(cr.CreationMoneyCostValue))
		Default
			go.ObjectMoneyType.SelectItem(Null)
		End Select
		
		go.ObjectGroup.SetText(cr.CreationGroup)
		go.ObjectMoveSpeed.SetText(cr.MoveSpeed)
		go.ObjectTurnSpeed.SetText(cr.TurnSpeed)
		
		go.ObjectSoundOnDie.SetText(cr.OnDie_SoundName)
		go.ObjectSoundOnEating.SetText(cr.OnEating_SoundName)
		
	End Function
	
	Function OnUpdatePortalParemetrs(sender:NUI_Control)
		Local go:TEditorGuiObjects = Editor.GuiObjects
		
		If go.SelectedObjects = Null Then Return
		If go.SelectedObjects.Objs.Count() <> 1 Then Return
		
		If TCreation(go.SelectedObjects.Objs.Last()).CreationType <> "Portal" Then Return

		Local cr:TCreationPortal = TCreationPortal(go.SelectedObjects.Objs.Last())
		
		cr.LevelID = go.PortalLevelID.GetText().ToInt()
		
		Select go.PortalType.GetSelectedItem()
		Case go.PortalType_Null
			cr.PortalType = 0
		Case go.PortalType_Next
			cr.PortalType = 1
		Case go.PortalType_Prev
			cr.PortalType = 2
		Case go.PortalType_World
			cr.PortalType = 3
		Default
		End Select
		
	End Function

	Function OnSetPortalParemetrs(sender:NUI_TabPage,cancel:Int Var)
		Local go:TEditorGuiObjects = Editor.GuiObjects
		
		If go.SelectedObjects = Null Then Return
		If go.SelectedObjects.Objs.Count() <> 1 Then Return
		
		If TCreation(go.SelectedObjects.Objs.Last()).CreationType <> "Portal" Then Return

		Local cr:TCreationPortal = TCreationPortal(go.SelectedObjects.Objs.Last())
		
		go.PortalLevelID.SetText(cr.LevelID)
		
		Select cr.PortalType
		Case 0
			go.PortalType.SelectItem(go.PortalType_Null)
		Case 1
			go.PortalType.SelectItem(go.PortalType_Next)
		Case 2
			go.PortalType.SelectItem(go.PortalType_Prev)
		Case 3
			go.PortalType.SelectItem(go.PortalType_World)
		Default
		End Select
		
	End Function

	Function OnUpdateScriptParemetrs(sender:NUI_Control)
		Local go:TEditorGuiObjects = Editor.GuiObjects
		
		If go.SelectedObjects = Null Then Return
		If go.SelectedObjects.Objs.Count() <> 1 Then Return
		
		Local cr:TCreation = TCreation(go.SelectedObjects.Objs.Last())

		If Not go.ScriptTree.GetSelectedNode() Then Return
		
		Local sc:TScript = TScript(go.ScriptTree.GetSelectedNode().GetMetaData())
		Local node:NUI_TreeViewNode = go.ScriptTree.GetSelectedNode()
		
		If cr.Scripts Then 
			If sc <> Null Then
				cr.Scripts.Remove(sc)
				sc.Free()
				sc = Null
			End If
		Else
			cr.Scripts = New TList
		End If
		
		Select go.ScriptType.GetSelectedItem()
		Case go.ScriptType_ChangeBGMusic
			sc = TScriptChangeBGMusic.Create(go.ScriptParam1.GetText(),go.ScriptParam2.GetText().ToInt())
			sc.Creation = cr
			
			cr.Scripts.AddLast(sc)
			
			node.SetText(sc.ScriptType)
			node.SetMetaData(sc)		
		
		Case go.ScriptType_TextParametrs
			sc = TScriptTextParametrs.Create(go.ScriptParam1.GetText(),go.ScriptParam2.GetText().ToInt(),go.ScriptParam3.GetText().ToInt(),go.ScriptParam4.GetText().ToInt())
			sc.Creation = cr
			
			cr.Scripts.AddLast(sc)
			
			node.SetText(sc.ScriptType)
			node.SetMetaData(sc)		
		Case go.ScriptType_CreationInfo
			sc = TScriptCreationInfo.Create(go.ScriptParam1.GetText())
			sc.Creation = cr
			
			cr.Scripts.AddLast(sc)
			
			node.SetText(sc.ScriptType)
			node.SetMetaData(sc)		
		Case go.ScriptType_ChageBGColor
			sc = TScriptChangeBGColor.Create(go.ScriptParam1.GetText().ToInt(),go.ScriptParam2.GetText().ToInt(),go.ScriptParam3.GetText().ToInt(),go.ScriptParam4.GetText().ToInt())
			sc.Creation = cr
			
			cr.Scripts.AddLast(sc)
			
			node.SetText(sc.ScriptType)
			node.SetMetaData(sc)
		Case go.ScriptType_DropBonus
		
			sc = TScriptDropBonus.Create(go.ScriptParam1.GetText().ToInt())
			sc.Creation = cr
			
			cr.Scripts.AddLast(sc)
			
			node.SetText(sc.ScriptType)
			node.SetMetaData(sc)

		Case go.ScriptType_DropCreation
		
			sc = TScriptDropCreation.Create(go.ScriptParam1.GetText().ToInt(),go.ScriptParam2.GetText(),go.ScriptParam3.GetText().ToInt(),go.ScriptParam4.GetText().ToFloat())
			sc.Creation = cr
			
			cr.Scripts.AddLast(sc)
			
			node.SetText(sc.ScriptType)
			node.SetMetaData(sc)

		Case go.ScriptType_Null
		
			If cr.Scripts.IsEmpty() Then cr.Scripts = Null
		
		Default
		End Select

	End Function

	Function OnAddScriptButton(sender:NUI_Control)
		Local go:TEditorGuiObjects = Editor.GuiObjects
		
		If go.SelectedObjects = Null Then Return
		If go.SelectedObjects.Objs.Count() <> 1 Then Return
		
		Local node:NUI_TreeViewNode = NUI_TreeViewNode.Create("Null",NGui,go.ScriptTree)
		node.SetMetaData(Null)
		
	End Function
	Function OnRemoveScriptButton(sender:NUI_Control)
		Local go:TEditorGuiObjects = Editor.GuiObjects
		
		If go.SelectedObjects = Null Then Return
		If go.SelectedObjects.Objs.Count() <> 1 Then Return
		
		Local cr:TCreation = TCreation(go.SelectedObjects.Objs.Last())
		
		If Not go.ScriptTree.GetSelectedNode() Then Return
		
		Local sc:TScript = TScript(go.ScriptTree.GetSelectedNode().GetMetaData())
		
		If cr.Scripts And sc <> Null Then 
			cr.Scripts.Remove(sc)
			sc.Free()
			sc = Null
			If cr.Scripts.IsEmpty() Then
				cr.Scripts = Null
			End If
		End If
		
		Local node:NUI_TreeViewNode = go.ScriptTree._selectedNode
		
		node.Dispose()
		
		go.ScriptTree._children.Remove(node)
		go.ScriptTree._selectedNode = Null
		
	End Function
	
	Function OnScriptTreeSelect(sender:NUI_TreeView, node:NUI_TreeViewNode)
		Local go:TEditorGuiObjects = Editor.GuiObjects
		
		If go.SelectedObjects = Null Then Return
		If go.SelectedObjects.Objs.Count() <> 1 Then Return
		
		Local sc:TScript = TScript(node.GetMetaData())
		
		go.ScriptType.SelectItem(go.ScriptType_Null)
		go.ScriptParam1.SetText("0")
		go.ScriptParam2.SetText("0")
		go.ScriptParam3.SetText("0")
		go.ScriptParam4.SetText("0")
		
		If sc <> Null Then
			Select sc.ScriptType
			
			Case "ChangeBGMusic"
				go.ScriptParam1.SetText(TScriptChangeBGMusic(sc).MusicName)
				go.ScriptParam2.SetText(TScriptChangeBGMusic(sc).ChangeOnDie)
				go.ScriptType.SelectItem(go.ScriptType_ChangeBGMusic)
				
			Case "TextParametrs"
				go.ScriptParam1.SetText(TScriptTextParametrs(sc).ResName)
				go.ScriptParam2.SetText(TScriptTextParametrs(sc).AppearText)
				go.ScriptParam3.SetText(TScriptTextParametrs(sc).Vertical)
				go.ScriptParam4.SetText(TScriptTextParametrs(sc).Generate)
				go.ScriptType.SelectItem(go.ScriptType_TextParametrs)

			Case "CreationInfo"
				go.ScriptParam1.SetText(TScriptCreationInfo(sc).ResName)
				go.ScriptType.SelectItem(go.ScriptType_CreationInfo)
			
			Case "ChangeBGColor"
				go.ScriptParam1.SetText(TScriptChangeBGColor(sc).ColorType)
				go.ScriptParam2.SetText(TScriptChangeBGColor(sc).r)
				go.ScriptParam3.SetText(TScriptChangeBGColor(sc).g)
				go.ScriptParam4.SetText(TScriptChangeBGColor(sc).b)
				go.ScriptType.SelectItem(go.ScriptType_ChageBGColor)
				
			Case "DropBonus"
				go.ScriptParam1.SetText(TScriptDropBonus(sc).BonusID)
				go.ScriptType.SelectItem(go.ScriptType_DropBonus)

			Case "DropCreation"
				go.ScriptParam1.SetText(TScriptDropCreation(sc).DropMethod)
				go.ScriptParam2.SetText(TScriptDropCreation(sc).CreationType)
				go.ScriptParam3.SetText(TScriptDropCreation(sc).CreationParam)
				go.ScriptParam4.SetText(TScriptDropCreation(sc).DeltaTimer)
				go.ScriptType.SelectItem(go.ScriptType_DropCreation)
			
			Default
			
			End Select
		End If
		
	End Function
	
	Function OnSetScriptParemetrs(sender:NUI_TabPage,cancel:Int Var)
		Local go:TEditorGuiObjects = Editor.GuiObjects
		
		If go.SelectedObjects = Null Then Return
		If go.SelectedObjects.Objs.Count() <> 1 Then Return
		
		Local cr:TCreation = TCreation(go.SelectedObjects.Objs.Last())
	
		For Local ch:NUI_TreeViewNode = EachIn go.ScriptTree._children
			ch.Dispose()
		Next
		go.ScriptTree._children.Clear()

		go.ScriptParam1.SetText("0")
		go.ScriptParam2.SetText("0")
		go.ScriptParam3.SetText("0")
		go.ScriptParam4.SetText("0")

		If cr.Scripts <> Null Then
			For Local sc:TScript = EachIn cr.Scripts
				Local node:NUI_TreeViewNode = NUI_TreeViewNode.Create(sc.ScriptType,NGui,go.ScriptTree)
				node.SetMetaData(sc)
			Next
		End If
	
	End Function
	
	Function OnScriptTypeSelect(sender:NUI_ComboBox, item:NUI_ComboBoxItem)
'		Local go:TEditorGuiObjects = Editor.GuiObjects
'		
'		If go.SelectedObjects = Null Then Return
'		If go.SelectedObjects.Objs.Count() <> 1 Then Return
'		
'		go.ScriptParam1.SetText("0")
'		go.ScriptParam2.SetText("0")
'		go.ScriptParam3.SetText("0")
'		go.ScriptParam4.SetText("0")
'	
'		If item = go.ScriptType_DropCreation Then
'			go.ScriptParam1.SetText("1")
'			go.ScriptParam2.SetText("T")
'			go.ScriptParam3.SetText("-9999")
'			go.ScriptParam4.SetText("0")
'		End If
'		
	End Function
	
	Function OnLevelSelectObjects(sender:NUI_Control)
		Local go:TEditorGuiObjects = Editor.GuiObjects

		If go.LevelTree.GetSelectedNode() = Null Then Return
		
		Local obj:TCreation = TCreation(go.LevelTree.GetSelectedNode().GetMetaData())
		go.RotatingMode = 0
		go.MovingMode = 0
		
		If go.SelectedObjects = Null Then go.SelectedObjects = TEditorSelectedObjects.Create(0,0,1,1)
		go.SelectedObjects.Objs.Clear()
		go.SelectedObjects.Objs.AddLast(obj)
	End Function
	Function OnLevelDeleteObjects(sender:NUI_Control)
		Local go:TEditorGuiObjects = Editor.GuiObjects

		If go.LevelTree.GetSelectedNode() = Null Then Return
		
		Local obj:TCreation = TCreation(go.LevelTree.GetSelectedNode().GetMetaData())
		obj.Free()
		WorldManager.RemoveCreation(obj)
		
		If go.SelectedObjects = Null Then go.SelectedObjects = TEditorSelectedObjects.Create(0,0,1,1)
		go.SelectedObjects.Objs.Clear()
		go.RotatingMode = 0
		go.MovingMode = 0
		
		go.RecreateLevelTree()
	End Function
	
	Method RecreateLevelTree()
		For Local ch:NUI_TreeViewNode = EachIn LevelTree._children
			ch.Dispose()
		Next
		LevelTree._children.Clear()
		For Local cr:TCreation = EachIn WorldManager.CurrentWorld.CurrentLvl.LevelCreations
			Local num% = -1
			For Local i% = 0 To WorldManager.CurrentWorld.CurrentLvl.LevelCreations.Count()-1
				If WorldManager.CurrentWorld.CurrentLvl.LevelCreations.ValueAtIndex(i) = cr Then
					num = i
					Exit
				End If
			Next
					
			Local node:NUI_TreeViewNode = NUI_TreeViewNode.Create(cr.CreationType+" "+num,NGui,LevelTree)
			node.SetMetaData(cr)
		Next

	End Method

	Method Update()
	
		Local modangle% = Key.IsKeyDown(KEY_LCONTROL)
	
		'------------------------- CREATING CREATION -------------------------------------------------------------------------

		If CreateObjectMode = 1 Then
			'If MouseOnWindow() = 0 And Window._minimizing = 0 And Window._minimized = 0 Then
			'	Window.Minimize()
			'End If
			If Key.IsMouseDown(3) Then
				RotateWorldPosX = Camera.GetWorldX(MouseX())
				RotateWorldPosY = Camera.GetWorldY(MouseY())
				RotateCreation = Editor.CreationsDB.CreateObject(CreateObjectSelect,RotateWorldPosX,RotateWorldPosY)
				
				If RotateCreation <> Null Then
					RotateEnable = 1
					CreateObjectMode = 2
					
					Local num% = -1
					For Local i% = 0 To WorldManager.CurrentWorld.CurrentLvl.LevelCreations.Count()-1
						If WorldManager.CurrentWorld.CurrentLvl.LevelCreations.ValueAtIndex(i) = RotateCreation Then
							num = i
							Exit
						End If
					Next
					
					Local node:NUI_TreeViewNode = NUI_TreeViewNode.Create(RotateCreation.CreationType+" "+num,NGui,LevelTree)
					node.SetMetaData(RotateCreation)
				Else
					CreateObjectMode = 0
					CreateObjectSelect = Null
				End If
			End If
		End If
		
		If CreateObjectMode = 2 And RotateEnable = 1 Then
			If Key.IsMouseDown(3) = 0 Then
				RotateEnable = 0
				RotateCreation = Null
				CreateObjectMode = 0
				CreateObjectSelect = Null
			Else
				Local mx# = Camera.GetWorldX(MouseX())
				Local my# = Camera.GetWorldY(MouseY())
				RotateAngle = ATan2(RotateWorldPosY - my,RotateWorldPosX - mx)
				If modangle = 1 Then RotateAngle = RotateAngle - RotateAngle Mod 45
				RotateCreation.SetPosition(RotateWorldPosX,RotateWorldPosY,RotateAngle)
			End If
		End If

		'------------------------- Selection tools  -------------------------------------------------------------------------
		
		If CreateObjectMode = 0 Then
		
		
			If (MouseOnWindow() Or Editor.GuiMain.MouseOnWindow()) = 0 And SelectionMode = 0 And Key.IsMouseDown(1) = 1 Then
				SelectionMode = 1
				SelectionStartX = Camera.GetWorldX(MouseX())
				SelectionStartY = Camera.GetWorldY(MouseY())
			End If
			
			If SelectionMode = 1 And Key.IsMouseDown(1) = 0 Then
				SelectionMode = 0
				SelectionEndX = Camera.GetWorldX(MouseX())
				SelectionEndY = Camera.GetWorldY(MouseY())
				
				If SelectionEndX < SelectionStartX Then
					Local a# = SelectionStartX
					SelectionStartX = SelectionEndX
					SelectionEndX = a
				End If

				If SelectionEndY < SelectionStartY Then
					Local a# = SelectionStartY
					SelectionStartY = SelectionEndY
					SelectionEndY = a
				End If
				
				If SelectedObjects = Null Then
					SelectedObjects = TEditorSelectedObjects.Create(SelectionStartX,SelectionStartY,SelectionEndX,SelectionEndY)
				Else
					SelectedObjects.Find(SelectionStartX,SelectionStartY,SelectionEndX,SelectionEndY)
				End If
			End If
			
		Else
			SelectionMode = 0
		End If
		
		If SelectedObjects <> Null Then
			'----- delete :)
			If key.IsKeyHit(KEY_DELETE) And not MouseOnWindow() Then
				For Local obj:TCreation = EachIn SelectedObjects.Objs
					obj.Free()
					WorldManager.RemoveCreation(obj)
				Next
				SelectedObjects.Objs.Clear()
				RecreateLevelTree()
			End If

			' ------- moving
			If MovingMode = 0 And Key.IsMouseDown(1) = 1 And SelectedObjects.MouseOver() And Key.IsMouseDown(2) = 0 Then
				MovingMode = 1
			End If

			If Key.IsMouseDown(1) = 1 And MovingMode = 1 Then
				SelectionMode = 0
				If Key.IsMouseDown(2) = 0 Then
					For Local obj:TCreation = EachIn SelectedObjects.Objs
						Local x# = obj.DragX
						Local y# = obj.DragY
						Local angle# = obj.SetPositionAngle
						
						If modangle Then
							Local xn# = Ceil(Float(x)/64.0)
							'If x - xn > 0.5 Then
							'	x=(xn+1)*64
							'Else
								x = xn*64
							'End If

							Local yn# = Ceil(Float(y)/64.0)
							'If y - yn > 0.5 Then
							'	y=(yn+1)*64
							'Else
								y = yn*64
							'End If
						
						End If
						
						x :+ Game.MouseXSpeed
						y :+ Game.MouseYSpeed
												
						obj.SetPosition(x,y,angle)
					Next
				End If
			Else
				MovingMode = 2
			End If
			
			If MovingMode = 2 And Key.IsMouseDown(1) = 0 Then
				MovingMode = 0
			End If
			
			If Key.IsKeyDown(key_g) = 1 And Not MouseOnWindow() Then
				SelectionMode = 0
				If Key.IsMouseDown(2) = 0 Then
					For Local obj:TCreation = EachIn SelectedObjects.Objs
						obj.SetPosition(obj.DragX + Game.MouseXSpeed,obj.DragY + Game.MouseYSpeed,obj.SetPositionAngle)
					Next
				End If
			End If
			
			'------- rotating
			If Key.IsMouseDown(3) And RotatingMode = 0 And SelectedObjects.Objs.Count() > 0 Then
				RotatingMode = 1
				SelectedObjects.CalculateCenter()
				Local mx# = Camera.GetWorldX(MouseX())
				Local my# = Camera.GetWorldY(MouseY())
				RotatingAngle = ATan2(SelectedObjects.CenterY - my,SelectedObjects.CenterX - mx)
			End If
			If Key.IsKeyDown(key_r) And Not MouseOnWindow() And RotatingMode = 0 And SelectedObjects.Objs.Count() > 0 Then
				RotatingMode = 1
				Local mx# = Camera.GetWorldX(MouseX())
				Local my# = Camera.GetWorldY(MouseY())
				SelectedObjects.CenterX = mx
				SelectedObjects.CenterY = my
				RotatingAngle = 0
			End If

			If (Key.IsMouseDown(3) Or Key.IsKeyDown(key_r)) And Not MouseOnWindow() And RotatingMode = 1 And RotateEnable = 0 Then
				Local mx# = Camera.GetWorldX(MouseX())
				Local my# = Camera.GetWorldY(MouseY())
				Local angle# = ATan2(SelectedObjects.CenterY - my,SelectedObjects.CenterX - mx)
				
				Local delta# = angle - RotatingAngle
				'If modangle Then delta = delta - delta Mod 45
				
				SelectedObjects.RotateObjectToAngle(delta)
				RotatingAngle = angle
			Else
				RotatingMode = 0
			End If
			
			
		End If
		
		If CreateObjectMode = 0 And Key.IsKeyHit(Key_space) And Editor.CreationsDB.LastCreated <> Null Then
			CreateObjectMode = 1
			CreateObjectSelect = Editor.CreationsDB.LastCreated.TreeViewNode
		End If
		
	End Method
	
	Method Draw()
	
	
		'------------------------- CREATING CREATION -------------------------------------------------------------------------
		If CreateObjectMode = 1 Then
			SetBlend ALPHABLEND
			SetColor 255,0,0
			SetRotation 0
			SetScale 1,1
			SetAlpha 1
			
			Local mx# = MouseX()
			Local my# = MouseY()
			Local size# = 10
			DrawLine mx-size,my-size,mx+size,my+size
			DrawLine mx-size,my+size,mx+size,my-size
		End If

		If CreateObjectMode = 2 And RotateEnable = 1 Then
			SetBlend ALPHABLEND
			SetRotation 0
			SetScale 1,1
			SetAlpha 1
			
			SetColor 255,0,0
			Local mx# = MouseX()
			Local my# = MouseY()
			Local size# = 10
			DrawLine mx-size,my-size,mx+size,my+size
			DrawLine mx-size,my+size,mx+size,my-size

			SetColor 255,255,0
			DrawLine mx,my,Camera.GetScrX(RotateWorldPosX),Camera.GetScrY(RotateWorldPosY)

			SetColor 255,255,0
			mx = Camera.GetScrX(RotateWorldPosX)
			my = Camera.GetScrY(RotateWorldPosY)
			DrawLine mx-size,my-size,mx+size,my+size
			DrawLine mx-size,my+size,mx+size,my-size
		End If
		
		'------------------------- selection tools \ draw objects  -------------------------------------------------------------------------
		
		If Editor.Drawing = 1 Then
			SetRotation 0
			SetAlpha 1
			SetColor 255,255,255
			SetBlend ALPHABLEND
			SetScale 1,1
			For Local cr:TCreation = EachIn WorldManager.CurrentWorld.CurrentLvl.LevelCreations
				Local obj:TCreationObject = cr.gco(0)
				Local z# = 20
				Local x# = Camera.GetScrX(obj.x)
				Local y# = Camera.GetScrY(obj.y)
				DrawLine x-z,y-z,x+z,y+z
				DrawLine x-z,y+z,x+z,y-z
				DrawLine x-z,y-z,x-z,y+z
				DrawLine x-z,y-z,x+z,y-z
				DrawLine x-z,y+z,x+z,y+z
				DrawLine x+z,y-z,x+z,y+z
			Next
		End If
		
		If CreateObjectMode = 0 And SelectionMode = 1 Then
			SetRotation 0
			SetAlpha 1
			SetColor 255,255,0
			SetBlend ALPHABLEND
			SetScale 1,1
			
			Local x1# = Camera.GetScrX(SelectionStartX)
			Local y1# = Camera.GetScrY(SelectionStartY)
			Local x2# = MouseX()
			Local y2# = MouseY()
			
			DrawLine x1,y1,x2,y1
			DrawLine x1,y2,x2,y2
			DrawLine x1,y1,x1,y2
			DrawLine x2,y1,x2,y2
		End If
		
		If Editor.Drawing = 1 And SelectedObjects <> Null Then
			SelectedObjects.Draw()
		End If
		
		If CreateObjectMode = 0 And RotatingMode = 1 Then
			SetBlend ALPHABLEND
			SetRotation 0
			SetScale 1,1
			SetAlpha 1
			
			SetColor 255,0,0
			Local mx# = MouseX()
			Local my# = MouseY()
			Local size# = 10
			DrawLine mx-size,my-size,mx+size,my+size
			DrawLine mx-size,my+size,mx+size,my-size

			SetColor 255,255,0
			DrawLine mx,my,Camera.GetScrX(SelectedObjects.CenterX),Camera.GetScrY(SelectedObjects.CenterY)

			SetColor 255,255,0
			mx = Camera.GetScrX(SelectedObjects.CenterX)
			my = Camera.GetScrY(SelectedObjects.CenterY)
			DrawLine mx-size,my-size,mx+size,my+size
			DrawLine mx-size,my+size,mx+size,my-size
		End If

		
		
	End Method

	Method Free()
		
	End Method
	
	
	
End Type



Type TEditorSelectedObjects
	
	Field Objs:TList
	Field CenterX#
	Field CenterY#
	
	Method Find(x1#,y1#,x2#,y2#)
		Objs.Clear()
		
		For Local cr:TCreation = EachIn WorldManager.CurrentWorld.CurrentLvl.LevelCreations
			Local obj:TCreationObject = cr.gco(0)

			Local z# = 20
			
			Local bx1# = obj.x - z
			Local bx2# = obj.x + z
			Local by1# = obj.y - z
			Local by2# = obj.y + z
			
			If (bx2 > x1 And bx1 < x2) And (by2 > y1 And by1 < y2)
				Objs.AddLast(cr)
			End If
		Next
		
		If Objs.Count() = 1 Then
			Local can% = 0
			TEditorGuiObjects.OnSetObjectParemetrs(Null,can)
			TEditorGuiObjects.OnSetPortalParemetrs(Null,can)
			TEditorGuiObjects.OnSetScriptParemetrs(Null,can)
		End If
		
	End Method
	
	Method CalculateCenter()
		Local count# = 0
		CenterX = 0
		CenterY = 0
		
		For Local cr:TCreation = EachIn Objs
			Local obj:TCreationObject = cr.gco(0)
			CenterX :+ obj.x
			CenterY :+ obj.y
			count :+1
		Next
		
		CenterX = CenterX / count
		CenterY = CenterY / count
	End Method
	
	Method MouseOver%()
		Local mx# = Camera.GetWorldX(MouseX())
		Local my# = Camera.GetWorldY(MouseY())
		
		For Local cr:TCreation = EachIn Objs
			Local obj:TCreationObject = cr.gco(0)
			
			Local z# = 20
			Local x1# = obj.x - z
			Local x2# = obj.x + z
			Local y1# = obj.y - z
			Local y2# = obj.y + z
			
			If mx > x1 And mx < x2 And my > y1 And my < y2 Then
				Return 1
			End If
		Next
		
		Return 0
	End Method
	
	Method RotateObjectToAngle(DeltaAngle#)
	
		For Local cr:TCreation = EachIn Objs
			Local x# = cr.DragX
			Local y# = cr.DragY
			Local crangle# = cr.SetPositionAngle
			
			Local angle1# = ATan2(y - CenterY,x - CenterX)
			Local dist# = Sqr((CenterX-x)*(CenterX-x)+(CenterY-y)*(CenterY-y))
			
			x = CenterX + Cos(angle1+DeltaAngle)*dist
			y = CenterY + Sin(angle1+DeltaAngle)*dist
			
			cr.SetPosition(x,y,crangle + DeltaAngle)
		Next
	End Method
	
	Method Free()
		Objs.Clear()
		Objs = Null
	End Method
	
	Method Update()
		
	End Method
	
	Method Draw()
		SetBlend ALPHABLEND
		SetColor 255,0,0
		SetAlpha 1
		SetRotation 0
		SetScale 1,1
	
		For Local cr:TCreation = EachIn Objs
			Local obj:TCreationObject = cr.gco(0)
			
			Local z# = 20
			Local x# = Camera.GetScrX(obj.x)
			Local y# = Camera.GetScrY(obj.y)
			DrawLine x-z,y-z,x+z,y+z
			DrawLine x-z,y+z,x+z,y-z
			DrawLine x-z,y-z,x-z,y+z
			DrawLine x-z,y-z,x+z,y-z
			DrawLine x-z,y+z,x+z,y+z
			DrawLine x+z,y-z,x+z,y+z
			
		Next
	End Method

	Function Create:TEditorSelectedObjects(x1#,y1#,x2#,y2#)
		Local sel:TEditorSelectedObjects = New TEditorSelectedObjects
		sel.Objs = New TList
		sel.Find(x1,y1,x2,y2)
		Return sel
	End Function
	
End Type

