'animimage animator type


Type TAnimImage
	
	Field AnimationSpeed# ' in milisec per frame  , for example 1000/12 or 1000/25
	Field Image:TResourceAnimImage
	Field LastAnimationTime#
	Field Frame#
	
	Method Free()
		Image = Null
	End Method

	Method Draw(x#,y#,fr% = -1)
		If fr <> - 1 Then Frame = fr
		
		Image.DrawAnimResource(x,y,Frame)
		
		If ( MilliSecs() - LastAnimationTime) => AnimationSpeed  Then
			Frame:+ (Float(MilliSecs() - LastAnimationTime))/AnimationSpeed
			LastAnimationTime = MilliSecs()
			If Frame >= Image.CellCount Then Frame = Image.StartCell
		End If
	End Method
	
	Function CreateAnimImage:TAnimImage(Img:TResourceAnimImage,Speed#)
		Local AnImg:TAnimImage = New TAnimImage
		
		AnImg.AnimationSpeed = 1000.0 / Speed
		AnImg.Image = Img
		AnImg.LastAnimationTime = MilliSecs()
		AnImg.Frame = AnImg.Image.StartCell
		
		Return AnImg
	End Function


End Type
