
Type TBonusEating Extends TBonus
	Field Time#

	Method Add(obj:TCreationObject)
		
		Time = jMillisecs()

		If BonusState = 0 Then
			BonusStarted()
		Else
			TCreationSnake(cr).EatingProcess = 0
		End If
		
		If BonusState > 0 Then
			If BonusState > 4 Then
				Player.ScoreManager.Combo = 5
			Else
				Player.ScoreManager.Combo = BonusState + 1
			End If
		End If
		
		BonusState:+1
		
	End Method
	Method Update()
		If jMillisecs() - Time > 2000 Then
			BonusFailed()
		End If
		
		'If BonusState > 5 Then
		'	BonusEnded()
		'End If
	End Method
	Method Draw()
	End Method
	Method Free()
		Player.ScoreManager.Combo = 0
	End Method
	Method Serealize()
	End Method
	Method Activate()
	End Method
	Method Deactivate()
	End Method
	
	Function Create:TBonusEating(cr:TCreation)
		Local b:TBonusEating = New TBonusEating
		
		b.BonusName = "EatingBonus"
		b.ActiveBonus = 1
		
		b.Cr = cr
		b.BonusState = 0
		b.BonusCost = TBonusManager.GetBonusCost(b.BonusName)
		
		Return b
	End Function
	
End Type

