Type TEffectChangeObjectLevel Extends TEffect
	Field Obj:TCreationObject
	Field Time#
	Field NewLevel%
	
	Method Update()
		If Time < jMilliSecs() Then
			Obj.ChangeLevel(NewLevel)
			Free()
		End If
	End Method
	
	Method Draw()
	End Method
	
	Method Free()
		Obj = Null
		Effects.Remove(Self)
	End Method
	
	Function Create:TEffectChangeObjectLevel(obj:TCreationObject,lvl%,t%)
		Local e:TEffectChangeObjectLevel = New TEffectChangeObjectLevel
		e.Time = t + jMilliSecs()
		e.Obj = obj
		e.NewLevel = lvl
		
		Effects.AddLast(e)
		Return e
	End Function

End Type
