Type TEffectGuiLevel Extends TEffect
	Field Img:TResourceImage
	Field Img2:TResourceImage
	Field alpha# = 0
	Field triger# = 0
	
	Field m# = 0.03
	Method Update()
		Select triger
		Case 0
			Camera.GlobalAlpha = 0
			WorldManager.EnableLvlChange = 0
			triger=1
		Case 1
			Camera.GlobalAlpha:+m*dt*0.5
			alpha:+m*dt
			If alpha>1 Then triger=2
			If Camera.GlobalAlpha > 0.5 Then Camera.GlobalAlpha = 0.5
		Case 2
			Camera.GlobalAlpha:+m*dt*0.5
			alpha:-m*dt
			If alpha<0 Then triger=3
			If Camera.GlobalAlpha > 1 Then Camera.GlobalAlpha = 1
		Case 3
			Camera.GlobalAlpha = 1
			WorldManager.EnableLvlChange = 1
			Free()
		Default
		End Select
	End Method
	
	Method Draw()
		SetBlend ALPHABLEND
		SetAlpha alpha * Game.PauseGameAlpha
		SetScale 1,1
		SetRotation 0
		SetColor 255,255,255

		Camera.EnableGlobalAlpha = 0
		Img.DrawResource(Camera.GetWorldX(GraphicsWidth()/2),Camera.GetWorldY(GraphicsHeight()/2))
		If Img2 <> Null Then
			Img2.DrawResource(Camera.GetWorldX(GraphicsWidth()/2),Camera.GetWorldY(GraphicsHeight()/2) - Img2.Image().height/2)
		End If
		Camera.EnableGlobalAlpha = 1
	End Method
	
	Method Free()
		Img = Null
		Img2 = Null
		Obj = Null
		Effects.Remove(Self)
	End Method
	
	Function Create:TEffectGuiLevel(level%,world:TResourceImage = Null)
		Local e:TEffectGuiLevel = New TEffectGuiLevel
		e.Img =	GetResImage("Gui_Level"+level)
		e.Img2 = world
		
		Effects.AddLast(e)
		
		e.Update()
		Return e
	End Function

End Type
