'jimon packer

Type TPacker

	Field MasterPassword$
	Field AdditionalMasterPassword$
	
	Field PasswordsLength% = 128
	
	Field EnablePacking% = 0 'if 0 - use original files, if 1 - use pak files
	
	Field BuildPakFiles% = 0
	Field ClearPakFiles% = 0 'dont enable this fuck ! only if you really wont to delete this fuckings files !
	
	Method CodeString$(st$,pass$,code% = 1)
		Local out$
		For Local i% = 1 To PasswordsLength
			If code = 1 Then
				out :+ Chr(Asc(Mid(st$,i,1)) + Asc(Mid(pass$,i,1)))
			Else
				out :+ Chr(Asc(Mid(st$,i,1)) - Asc(Mid(pass$,i,1)))
			End If
		Next
		Return out
	End Method
	
	Method ByteCheck%(st1:String,st2:String,size%)
		For Local i% = 0 To size%-1
			If Byte(st1[i]) <> Byte(st2[i]) Then Return 0
		Next
		Return 1
	End Method

	Method DecodeStream:TStream(in:TStream)
		in.Seek(0)

		Local Header$ = in.ReadString(5)
		Local Version% = in.ReadInt()

		If Header <> "j2pak" Then RuntimeError "pak corrupt"
		If Version <> 1 Then RuntimeError "pak version dont support"
		
		Local x1#,x2#,x3#,x4#,x5#
		x1 = in.ReadFloat()
		x2 = in.ReadFloat()
		x3 = in.ReadFloat()
		x4 = in.ReadFloat()
		x5 = in.ReadFloat()
		
		If (x1 * x2 + x3 * x4) <> x5 Then RuntimeError "pak Checksum corrupt"
		
		Local MassPass$ = CodeString(in.ReadString(PasswordsLength),AdditionalMasterPassword,0)
		If ByteCheck(MassPass,MasterPassword,PasswordsLength) = 0 Then RuntimeError "pak Additional check corrupt, this programm dont support this type of paks"

		Local DataSize% = in.ReadInt() - 128

		Local bank:TBank = New TBank
		Local out_stream:TStream = OpenStream(bank)
		
		Local dat% = 0
		Local i% = 1
		
		Local checksum:Byte = 0

		For dat = 1 To DataSize
			Local out_byte:Byte = in.ReadByte() - Asc(Mid(MasterPassword,i,1))
			checksum :+ out_byte
			
			out_stream.WriteByte ( out_byte )
			
			i:+1
			If i > PasswordsLength Then i = 1
		Next
		
		Local InFileCheckSum:Byte = in.ReadByte()
		
		If InFileCheckSum <> checksum Then RuntimeError "pak data corrupt (CRC)"
				
		Local EndHeader$ = in.ReadString(7)
		If EndHeader <> "jformat" Then RuntimeError "pak data corrupt"
		
		out_stream.Seek(0)
		in.Seek(0)
		
		Return out_stream
	End Method

	Method CodeStream:TStream(in:TStream)
		Local bank:TBank = New TBank
		Local out_stream:TStream = OpenStream(bank)

		in.Seek(0)

		out_stream.WriteString("j2pak")
		out_stream.WriteInt(1)

		Local x1#,x2#,x3#,x4#,x5#
		SeedRnd MilliSecs()
		x1 = Rand(1,100)
		x2 = Rand(1,100)
		x3 = Rand(1,100)
		x4 = Rand(1,100)
		x5 = x1 * x2 + x3 * x4 'simply check sum
		
		out_stream.WriteFloat(x1)
		out_stream.WriteFloat(x2)
		out_stream.WriteFloat(x3)
		out_stream.WriteFloat(x4)
		out_stream.WriteFloat(x5)
		
		out_stream.WriteString(CodeString(MasterPassword,AdditionalMasterPassword))
		
		out_stream.WriteInt(in.Size() + 128)
		
		Local checksum:Byte = 0
		
		Local i% = 1
		While Not Eof(in)
			Local read_byte:Byte = in.ReadByte()
			checksum:+read_byte
			
			out_stream.WriteByte ( read_byte + Asc(Mid(MasterPassword,i,1)) )
			
			i:+1
			If i > PasswordsLength Then i = 1
		Wend
		
		out_stream.WriteByte(checksum)

		out_stream.WriteString("jformat")

		out_stream.Seek(0)
		in.Seek(0)
		
		Return out_stream
	End Method
	
	Method CodeStreamFast:TStream(in:TStream)
		Local bank:TBank = New TBank
		Local out_stream:TStream = OpenStream(bank)
		in.Seek(0)
		Local i% = 1
		While Not Eof(in)
			out_stream.WriteByte ( in.ReadByte() + (i*i-4*i) * 3 )
			i:+1
			If i > 8 Then i = 1
		Wend
		out_stream.Seek(0)
		in.Seek(0)
		Return out_stream
	End Method

	Method DeCodeStreamFast:TStream(in:TStream)
		Local bank:TBank = New TBank
		Local out_stream:TStream = OpenStream(bank)
		in.Seek(0)
		Local i% = 1
		While Not Eof(in)
			out_stream.WriteByte ( in.ReadByte() - (i*i-4*i) * 3 )
			i:+1
			If i > 8 Then i = 1
		Wend
		out_stream.Seek(0)
		in.Seek(0)
		Return out_stream
	End Method
	
	
	Method Free()
		
	End Method

	Function CreatePacker()
		Local pak:TPacker = New TPacker
		
		If TGame.ReleaseVersion = 1 Then pak.EnablePacking = 1

		Local magic_1$ = "12345"
		Local magic_2$ = "12345"
		Local magic_3$ = "12345"

		pak.MasterPassword = pak.CodeString(magic_1,magic_3)
		pak.AdditionalMasterPassword = pak.CodeString(magic_2,magic_3)
		
		Packer = pak
	End Function
	
End Type

Function ReadPakFile:TStream(filename$)
	Local file:TStream
	
	If Packer.EnablePacking = 0 Then
		file = ReadFile(filename)
		Return file
	End If
	
	If Packer.BuildPakFiles = 1 Then
		file = ReadFile(filename)

		Local file_out:TStream = WriteFile(filename$+"_pak")
		Local out:TStream = Packer.CodeStream(file)
		While Not Eof(out)
			file_out.WriteByte(out.ReadByte())
		Wend
		'file_out.WriteObject(out.ReadObject())
		
		CloseFile file_out
		out.Close()
		
		Return file
	ElseIf Packer.ClearPakFiles = 1
		DeleteFile(filename$+"_pak")
	
		file = ReadFile(filename)
		Return file
	Else
		file = ReadFile(filename$ + "_pak")

		Local out:TStream = Packer.DecodeStream(file)
		CloseFile(file)

		Return out
	End If
End Function

Global SerealizeEnable% = 0
Global SerealizeFlag% = 0
Global SerealizeStream:TStream = Null
Global CurrentSerealizeVersion%

Function StartSerealize(s:TStream,flag%,version% = -1)
	If SerealizeEnable = 0 Then
		SerealizeStream = s
		SerealizeEnable = 1
		SerealizeFlag = flag

		Select SerealizeFlag
		Case 1
			If version = -1 Then
				CurrentSerealizeVersion = Game.SerealizeVersion
			Else
				CurrentSerealizeVersion = version
			End If
			s.WriteLine("jimon ser")
			s.WriteInt(CurrentSerealizeVersion)
		Case 2
			If (s.ReadLine() <> "jimon ser") Then RuntimeError "wtf sheet"
			CurrentSerealizeVersion = s.ReadInt()
			If version <> -1 Then CurrentSerealizeVersion = version
		End Select
	Else
		RuntimeError "please close serealized stream !"
	End If
End Function
Function EndSerealize()
	If SerealizeEnable = 1 Then
		SerealizeFlag = 0
		SerealizeEnable = 0
		SerealizeStream = Null
	Else
		RuntimeError "please open serealized stream !"
	End If
End Function

Function SerInt(i% Var)
	If SerealizeEnable = 0 Then Return
	Select SerealizeFlag
	Case 1
		SerealizeStream.WriteInt(i)
	Case 2
		i = SerealizeStream.ReadInt()
	End Select
End Function
Function SerFloat(i# Var)
	If SerealizeEnable = 0 Then Return
	Select SerealizeFlag
	Case 1
		SerealizeStream.WriteFloat(i)
	Case 2
		i = SerealizeStream.ReadFloat()
	End Select
End Function
Function SerLine(i$ Var)
	If SerealizeEnable = 0 Then Return
	Select SerealizeFlag
	Case 1
		SerealizeStream.WriteLine(i)
	Case 2
		i = SerealizeStream.ReadLine()
	End Select
End Function
