
'change tile map bg color on die

Type TScriptChangeBGColor Extends TScript
	Field ColorType%
	Field r#,g#,b#

	Method OnEvent(ScriptEventData:TScriptEventData)
		If Not ScriptEventData Then Return
		
		Select ScriptEventData.EventName
		Case TScriptEventData.OnDie
			TileMap.SetBGColor(ColorType,r,g,b)
			
			ScriptEventData.Creation.Scripts.Remove(Self)
			Free()
			Return
		Default
		End Select
	End Method
	
	Method Free()
		Creation = Null
	End Method
	
	Method Update()
	End Method
	
	Method Draw()
	End Method
	
	Method AddCollisionRequest()
	End Method
	
	Method SerealizeScript()
		SerInt(ColorType)
		SerFloat(r)
		SerFloat(g)
		SerFloat(b)
	End Method
	
	Function Create:TScript(ColorType%,r#,g#,b#)
		Local sc:TScriptChangeBGColor = New TScriptChangeBGColor
		sc.ScriptType = "ChangeBGColor"
		sc.ColorType = ColorType
		sc.r = r
		sc.g = g
		sc.b = b
		Return sc
	End Function
End Type

