Include "TScriptDropBonus.bmx"
Include "TScriptDropCreation.bmx"
Include "TScriptChangeBGColor.bmx"
Include "TScriptCreationInfo.bmx"
Include "TScriptTextParametrs.bmx"
include "TScriptChangeBGMusic.bmx"

Type TScriptEventData
	Const OnDie% = 1
	Const OnFreeScript% = 2

	Field EventName%
	Field Creation:TCreation
	Field Script:TScript
	
	Method Free()
		Creation = Null
		Script = Null
	End Method
	
	Function Create:TScriptEventData(Name%,Creation:TCreation = Null,Script:TScript = Null)
		Local ed:TScriptEventData = New TScriptEventData
		ed.EventName = Name
		ed.Creation = Creation
		ed.Script = Script
		Return ed
	End Function
End Type

Type TScript
	Field ScriptType$
	Field Creation:TCreation
	
	Method AddCollisionRequest() Abstract
	Method OnEvent(ScriptEventData:TScriptEventData) Abstract
	Method Free() Abstract
	Method Update() Abstract
	Method Draw() Abstract
	
	Method SerealizeScript() Abstract
	Method Serealize()
	End Method
	
End Type
