

Type TScriptTextParametrs Extends TScript

	Field ResName$
	Field AppearText%
	Field Vertical%
	Field Generate%
	
	Field FirstRun%
	
	Method OnEvent(ScriptEventData:TScriptEventData)
		If Not ScriptEventData Then Return
		
		Select ScriptEventData.EventName
		Case TScriptEventData.OnDie
			ScriptEventData.Creation.Scripts.Remove(Self)
			Free()
			Return
		Default
		End Select
	End Method
	
	Method Free()
		Creation = Null
	End Method
	
	Method Update()
		If Creation.CreationType <> "MenuSimple" Then
			Creation.Scripts.Remove(Self)
			Free()
			Return
		End If
		
		If FirstRun = 0 Then
			TCreationMenuSimple(Creation).GetObj().MakeEffectText(ResName,AppearText,Vertical,Generate)
			FirstRun = 1
		End If
	End Method
	
	Method Draw()
	End Method
	
	Method AddCollisionRequest()
	End Method
	
	Method SerealizeScript()
		SerLine(ResName)
		SerInt(AppearText)
		SerInt(Vertical)
		SerInt(Generate)
		
		FirstRun = 0
	End Method
	
	Function Create:TScript(name$,appear%,vertical%,generate%)
		Local sc:TScriptTextParametrs = New TScriptTextParametrs
		sc.ScriptType = "TextParametrs"
		
		sc.ResName = name
		sc.AppearText = appear
		sc.Vertical = vertical
		sc.Generate = generate
		Return sc
	End Function
End Type

