
Type TBonusLife Extends TBonus

	Field BonusObject:TCreationObject

	Method Add(obj:TCreationObject)
	End Method
	
	Method Update()
		If Cr <> Null Then
			If Not Cr.CreationObjects.Contains(BonusObject) Then
				Player.BonusManager.RemovePlayerBonus(Self,0)
				Return
			End If
			If BonusObject.Hp = 0 Then Player.BonusManager.RemovePlayerBonus(Self,0)
		End If
	End Method
	
	Method Draw()
	End Method
	
	Method Free()
		BonusObject = Null
		BonusImage = Null
	End Method
	
	Method Serealize()
		If Cr = Null Then Return
	
		Local objgr%,objgrn%
		
		If BonusObject <> Null Then
			objgrn = BonusObject.CreationInGroupNum
			objgr = BonusObject.CreationGroupId
		End If
		
		SerInt(objgr)
		SerInt(objgrn)
		
		BonusObject = Cr.gcgo(objgrn,objgr)
	End Method
	
	Method Activate()
		If Cr = Null Then Return
		If Activated = 1 Then Return
		
		BonusObject = TCreationSnakeObject.Create(202)
		
		Local ObjConnect:TCreationObject = Null
		For Local Obj:TCreationObject = EachIn Cr.gcg(1).Objects
			If Obj.Group > (BonusObject.Group-1) Then
				ObjConnect = Obj
				Exit
			End If
		Next
		
		Cr.AddCreationObject(BonusObject,-1,ObjConnect,0,1)
		
		Activated = 1
	End Method

	Method Deactivate()
		If Cr = Null Then Return
		If Activated = 0 Then Return
		
		If BonusObject <> Null Then
			Cr.SubCreationObject(BonusObject)
			BonusObject = Null
		End If

		Activated = 0
	End Method
	
	Function Create:TBonusLife()
		Local b:TBonusLife = New TBonusLife
		
		b.BonusName = "LifeBonus"
		b.ActiveBonus = 0
		b.BonusState = 0
		b.BonusCost = 50

		
		Local bonus:TAnimationModel = GetResModel("Bonus_Model").CreateModel()
		
		b.BonusImage = bonus.GetAnimation("Bonus_02").Image
		
		bonus.Free()
		bonus = Null
		
		b.BonusCost = TBonusManager.GetBonusCost(b.BonusName)
		
		Return b
	End Function
	
End Type

