
Type TBonusShapes Extends TBonus

	Field BonusInObject:TCreationObject
	Field BonusGroupNum1% = -1
	Field BonusGroupNum2% = -1

	Method Add(obj:TCreationObject)
	End Method
	
	Method Update()
		If Cr <> Null Then
			If BonusInObject.Hp = 0 Then Player.BonusManager.RemovePlayerBonus(Self)
		End If
	End Method
	
	Method Draw()
	End Method
	
	Method Free()
		BonusInObject = Null
		BonusImage = Null
	End Method
	
	Method Serealize()
		If Cr = Null Then Return
		
		Local objgr%,objgrn%
		
		If BonusInObject <> Null Then
			objgrn = BonusInObject.CreationInGroupNum
			objgr = BonusInObject.CreationGroupId
		End If
		
		SerInt(objgr)
		SerInt(objgrn)
		
		BonusInObject = Cr.gcgo(objgrn,objgr)
	
		SerInt(BonusGroupNum1)
		SerInt(BonusGroupNum2)
	End Method
	
	Method Activate()
		If Cr = Null Then Return
		
		If Activated = 1 Then Return
		
		BonusInObject = TCreationSnakeObject.Create(401)

		Local ObjConnect:TCreationObject = Null
		For Local Obj:TCreationObject = EachIn Cr.gcg(1).Objects
			If Obj.Group > (BonusInObject.Group-1) Then
				ObjConnect = Obj
				Exit
			End If
		Next

		Cr.AddCreationObject(BonusInObject,-1,ObjConnect,0,1)
		
		Local GroupId1% = Cr.Getgcid()
		Local GroupId2% = GroupId1 + 1
	
		For Local i% = 0 To 5
			Cr.AddCreationObject(TCreationSnakeObject.Create(101),-1,Null,0,GroupId1)
			TCreationObject(Cr.CreationObjects.Last()).DragType = 1
			TCreationObject(Cr.CreationObjects.Last()).DragADist = 16
			TCreationObject(Cr.CreationObjects.Last()).Angle = -30
		Next
		Cr.gcg(GroupId1).SetSettings(Cr.gcg(1),-1,-60,1,10,BonusInObject)
		BonusGroupNum1 = GroupId1

		For Local i% = 0 To 5
			Cr.AddCreationObject(TCreationSnakeObject.Create(101),-1,Null,0,GroupId2)
			TCreationObject(Cr.CreationObjects.Last()).DragType = 1
			TCreationObject(Cr.CreationObjects.Last()).DragADist = 16
			TCreationObject(Cr.CreationObjects.Last()).Angle = 30
		Next
		Cr.gcg(GroupId2).SetSettings(Cr.gcg(1),-1,60,1,10,BonusInObject) 'a 30 , dist 24
		BonusGroupNum2 = GroupId2
		
		Activated = 1
	End Method
	
	Method Deactivate()
		If Cr = Null Then Return
		
		If Activated = 0 Then Return

		If BonusGroupNum1 <> -1 Then
			For Local Obj:TCreationObject = EachIn Cr.gcg(BonusGroupNum1).Objects
				If Obj.level = 101 Then
					Cr.SubCreationObject(Obj)
				Else
					Cr.SubCreationObject(Obj,0)
					Local ObjConnect:TCreationObject = Null
					For Local Obj2:TCreationObject = EachIn Cr.gcg(1).Objects
						If Obj2.Group > (Obj.Group-1) Then
							ObjConnect = Obj2
							Exit
						End If
					Next
					Cr.AddCreationObject(Obj,-1,ObjConnect,0,1)
					Obj.DragType = ObjConnect.DragType
					Obj.DragADist = ObjConnect.DragADist
					Obj.Angle = ObjConnect.Angle
				End If
			Next
			BonusGroupNum1 = -1
		End If
		If BonusGroupNum2 <> -1 Then
			For Local Obj:TCreationObject = EachIn Cr.gcg(BonusGroupNum2).Objects
				If Obj.level = 101 Then
					Cr.SubCreationObject(Obj)
				Else
					Cr.SubCreationObject(Obj,0)
					Local ObjConnect:TCreationObject = Null
					For Local Obj2:TCreationObject = EachIn Cr.gcg(1).Objects
						If Obj2.Group > (Obj.Group-1) Then
							ObjConnect = Obj2
							Exit
						End If
					Next
					Cr.AddCreationObject(Obj,-1,ObjConnect,0,1)
					Obj.DragType = ObjConnect.DragType
					Obj.DragADist = ObjConnect.DragADist
					Obj.Angle = ObjConnect.Angle
				End If
			Next
			BonusGroupNum2 = -1
		End If
		If BonusInObject <> Null Then
			Cr.SubCreationObject(BonusInObject)
			BonusInObject = Null
		End If
		
		Activated = 0
	End Method
	
	Function Create:TBonusShapes()
		Local b:TBonusShapes = New TBonusShapes
		
		b.BonusName = "ShapesBonus"
		b.ActiveBonus = 0
		b.BonusState = 0
		
		Local bonus:TAnimationModel = GetResModel("Bonus_Model").CreateModel()
		
		b.BonusImage = bonus.GetAnimation("Bonus_01").Image
		
		bonus.Free()
		bonus = Null
		
		b.BonusCost = TBonusManager.GetBonusCost(b.BonusName)

		
		Return b
	End Function
	
End Type

