
Type TBonusSpeed Extends TBonus
	Const SpeedBonus# = 1

	Method Add(obj:TCreationObject)
	End Method
	
	Method Update()
	End Method
	
	Method Draw()
	End Method
	
	Method Free()
		BonusImage = Null
	End Method
	
	Method Serealize()
	End Method
	
	Method Activate()
		If Player = Null Or Activated = 1 Then Return
		
		Player.Control.PlayerSpeedMax:+TBonusSpeed.SpeedBonus
		
		Activated = 1
	End Method
	Method Deactivate()
		If Player = Null Or Activated = 0 Then Return

		Player.Control.PlayerSpeedMax:-TBonusSpeed.SpeedBonus
		
		Activated = 0
	End Method
	
	Function Create:TBonusSpeed()
		Local b:TBonusSpeed = New TBonusSpeed
		
		b.BonusName = "SpeedBonus"
		b.ActiveBonus = 0
		b.BonusState = 0
		
		Local bonus:TAnimationModel = GetResModel("Bonus_Model").CreateModel()
		
		b.BonusImage = bonus.GetAnimation("Bonus_05").Image
		
		bonus.Free()
		bonus = Null
		
		b.BonusCost = TBonusManager.GetBonusCost(b.BonusName)
		
		Return b
	End Function
	
End Type

