Type TEffectCreateObjectLevel Extends TEffect
	Field Time#
	Field Cr:TCreation
	Field Obj:TCreationObject
	
	Method Update()
		If Time < jMilliSecs() Then
			Cr.AddCreationObject(Obj)
			Free()
		End If
	End Method
	
	Method Draw()
	End Method
	
	Method Free()
		Cr = Null
		Obj = Null
		
		Effects.Remove(Self)
	End Method
	
	Function Create:TEffectCreateObjectLevel(Cr:TCreation, Obj:TCreationObject, Time%)
		Local e:TEffectCreateObjectLevel = New TEffectCreateObjectLevel
		e.Time = Time + jMilliSecs()
		e.Obj = Obj
		e.Cr = Cr
		
		Effects.AddLast(e)
		Return e
	End Function

End Type
