
Include "TPlayerControl.bmx"
Include "TPlayerNavigation.bmx"
Include "TScoreManager.bmx"
Include "TBonusManager.bmx"
Include "TBonusShop.bmx"

Type TPlayer
	Field Creation:TCreation
	
	Field Navigation:TPlayerNavigation
	Field Control:TPlayerControl
	Field ScoreManager:TScoreManager
	Field BonusManager:TBonusManager
	
	Field BonusShop:TBonusShop
	
	Method Update()
		Control.Update()
		Navigation.Update()
		ScoreManager.Update()
		BonusManager.Update()
	End Method
	
	Method Draw()
		Control.Draw()
		Navigation.Draw()
		ScoreManager.Draw()
		BonusManager.Draw()
	End Method
	
	Method Free()
		BonusManager.Free()
		BonusManager = Null
		
		BonusShop.Free()
		BonusShop = Null

		Navigation.Free()
		Navigation = Null
		
		ScoreManager.Free()
		ScoreManager = Null
		
		Control.Free()
		Control = Null

		Creation = Null
	End Method
	
	Method Serealize()
		Control.Serealize()
		BonusManager.Serealize()
		ScoreManager.Serealize()
	End Method

	Function CreatePlayer(cr:TCreation)
		Local p:TPlayer=New TPlayer
		
		p.Creation = cr
		If cr <> Null Then p.Creation.PlayerControlable = 1
		
		p.Control = TPlayerControl.Create()
		p.Navigation = TPlayerNavigation.Create()
		p.ScoreManager = TScoreManager.Create()
		p.BonusManager = TBonusManager.Create()
		
		p.BonusShop = TBonusShop.Create()
		
		Player = p
	End Function
	
End Type
