'image resource

Type TResourceImage Extends TResource

	Field iImage:TImage
	Field File_Name$

	Method DrawResource(x#,y#)
		LoadChecks()
		DrawImg(iImage,x,y)
	End Method
	
	Method Image:TImage()
		LoadChecks()
		Return iImage
	End Method

	Method Free()
		If LockFree% = 0 Then
			iImage = Null
			If T_Str <> Null Then
				T_Str.Close()
				T_Str = Null
			End If
		End If
	End Method
	
	Method WorkUnLoad()
		iImage = Null
	End Method
	Method WorkLoad()
		If iImage = Null Then
			If T_Str = Null Then T_Str = ReadPakFile(File_Name)
			
			T_Str.Seek(0)
			
			LoadingCacheResource()
			iImage = LoadImage(T_Str)
			LoadingCacheResource(1)

			Assert iImage,"Filed to dynamic load image resource : "+Name$+" file : "+File_Name$
			MidHandleImage iImage
		End If
	End Method
	
	Function LoadResource:TResourceImage(file$,name$)
		Local Res:TResourceImage = New TResourceImage
		Res.T_Str = ReadPakFile(file$)
		
		If ResourceManager.NullLoading = 1 Then
			Res.iImage = Null
			Res.UnLoad = 1
		Else
			Res.LoadingCacheResource()
			Res.iImage = LoadImage(Res.T_Str)'DYNAMICIMAGE
			Res.LoadingCacheResource(1)
		
			Assert Res.iImage,"Filed to load image resource : "+name$+" file : "+file$

			MidHandleImage Res.iImage
		End If

		Res.Name = name
		Res.File_Name = file
		Res.ResType$ = "Image"
		
		Return Res
	End Function
End Type

Function GetResImage:TResourceImage(name$)
	Return TResourceImage(ResourceManager.GetResource(name))
End Function

Function NewImageRes(file$,resname$)
	ResourceManager.CreateNewRes(TResource(TResourceImage.LoadResource(File,ResName)))
End Function
