'sound resource

Type TResourceSound Extends TResource

	Field Sound% = 0
	Field SoundChanel% = 0

	Method Free()
		If LockFree% = 0 Then Sound = 0
	End Method
	
	Method Play(looped% = 0,free% = 1)
		If SoundChanel <> 0 And free = 1 Then SQUALL_Channel_Stop(SoundChanel) 
		SoundChanel = SQUALL_Sample_Play(Sound,looped)
	End Method
	
	Method Pause(pause:Int) 
		SQUALL_Channel_Pause(SoundChanel, pause) 
	End Method
	
	Method WorkUnLoad()
	End Method
	Method WorkLoad()
	End Method
	
	Function LoadResource:TResourceSound(file$,name$)
		Local Res:TResourceSound = New TResourceSound
		'DebugLog "2 "+file
		Res.Sound = SQUALL_Sample_LoadFile(file, 0) 
		'Res.Sound = fmusic_loadsong(file.ToCString())
		
		'Assert Res.Sound, "Filed to load sound resource : " + name:String + " file : " + file:String

		Res.Name = name
		Res.ResType$ = "Sound"
		
		Return Res
	End Function
End Type

Function GetResSound:TResourceSound(name$)
	Return TResourceSound(ResourceManager.GetResource(name))
End Function

Function NewSoundRes(file$,resname$)
	ResourceManager.CreateNewRes(TResource(TResourceSound.LoadResource(File,ResName)))
End Function



'Function SQUALL_Init(Param:Int=0)
'Function SQUALL_Sample_LoadFile(FIleName$z,MemFlag:Int=True,param:Int=0)
'Function SQUALL_Sample_Play(SampleID:Int, Loop:Int, Group:Int=0, Start:Int=True)
'Function  SQUALL_Free()
'
'Function SQUALL_Channel_Pause(ChannelID:Int,Pause:Int)
'Function SQUALL_Channel_Stop(ChannelID:Int)
'
'Const  SQUALL_CHANNEL_STATUS_NONE=0
'Const SQUALL_CHANNEL_STATUS_PLAY=1 
'Const SQUALL_CHANNEL_STATUS_PAUSE=2
'Const SQUALL_CHANNEL_STATUS_PREPARED=3
'
'Function SQUALL_Channel_Status:Int(ChannelID:Int)
'Function SQUALL_Channel_SetVolume(ChannelID:Int,Volume:Int)
'Function SQUALL_Sample_UnloadAll()

