

Type TScriptChangeBGMusic Extends TScript
	Field MusicName$
	Field ChangeOnDie%
	Field ok%

	Method OnEvent(ScriptEventData:TScriptEventData)
		If Not ScriptEventData Then Return
		
		Select ScriptEventData.EventName
		Case TScriptEventData.OnDie
			If ChangeOnDie Then ChangeMusic()
		
			ScriptEventData.Creation.Scripts.Remove(Self)
			Free()
			Return
		Default
		End Select
	End Method
	
	Method ChangeMusic()
		If ok Then Return
		ok = 1
		If SoundLib.CurrentMusic And SoundLib.CurrentMusic.Name = MusicName Then Return
		SoundLib.PlayMusic(MusicName)
	End Method
	
	Method Free()
		Creation = Null
	End Method
	
	Method Update()
		If Not ChangeOnDie Then ChangeMusic()
	End Method
	
	Method Draw()
	End Method
	
	Method AddCollisionRequest()
	End Method
	
	Method SerealizeScript()
		SerLine(MusicName)
		SerInt(ChangeOnDie)
		
		ok = 0
	End Method
	
	Function Create:TScript(name$,change_ondie% = 0)
		Local sc:TScriptChangeBGMusic = New TScriptChangeBGMusic
		sc.ScriptType = "ChangeBGMusic"
		sc.MusicName = name
		sc.ChangeOnDie = change_ondie
		Return sc
	End Function
End Type

